diff --git a/lib/app/modules/profile/views/profile_view.dart b/lib/app/modules/profile/views/profile_view.dart
index 4fc149b..6028d49 100644
--- a/lib/app/modules/profile/views/profile_view.dart
+++ b/lib/app/modules/profile/views/profile_view.dart
@@ -87,6 +87,7 @@ class ProfileView extends GetView<ProfileController> {
   Widget _buildProfileForm() {
     return Obx(() {
       final isEditing = controller.isEditing.value;
+      final user = controller.user.value;
 
       return Column(
         crossAxisAlignment: CrossAxisAlignment.start,
@@ -119,7 +120,7 @@ class ProfileView extends GetView<ProfileController> {
               labelText: 'Email',
               border: OutlineInputBorder(),
               prefixIcon: Icon(Icons.email),
-              enabled: isEditing,
+              enabled: false, // Email tidak bisa diubah
             ),
             keyboardType: TextInputType.emailAddress,
           ),
@@ -136,6 +137,113 @@ class ProfileView extends GetView<ProfileController> {
             ),
             keyboardType: TextInputType.phone,
           ),
+          const SizedBox(height: 16),
+
+          // Informasi tambahan sesuai role
+          if (user != null) ...[
+            if (user.role?.toLowerCase() == 'warga') ...[
+              const SizedBox(height: 24),
+              const Text(
+                'Informasi Warga',
+                style: TextStyle(
+                  fontSize: 18,
+                  fontWeight: FontWeight.bold,
+                ),
+              ),
+              const SizedBox(height: 16),
+              Obx(() {
+                final roleData = controller.roleData.value;
+                return Column(
+                  crossAxisAlignment: CrossAxisAlignment.start,
+                  children: [
+                    _buildInfoRow(
+                        Icons.perm_identity, 'NIK', roleData?['nik'] ?? '-'),
+                    const SizedBox(height: 8),
+                    _buildInfoRow(Icons.wc, 'Jenis Kelamin',
+                        roleData?['jenis_kelamin'] ?? '-'),
+                    const SizedBox(height: 8),
+                    _buildInfoRow(
+                        Icons.home, 'Alamat', roleData?['alamat'] ?? '-'),
+                    if (user.desa != null) ...[
+                      const SizedBox(height: 8),
+                      _buildInfoRow(
+                          Icons.location_city, 'Desa', user.desa!.nama),
+                      const SizedBox(height: 8),
+                      _buildInfoRow(Icons.location_on, 'Kecamatan',
+                          user.desa!.kecamatan ?? ''),
+                      const SizedBox(height: 8),
+                      _buildInfoRow(Icons.location_on, 'Kabupaten',
+                          user.desa!.kabupaten ?? ''),
+                      const SizedBox(height: 8),
+                      _buildInfoRow(Icons.location_on, 'Provinsi',
+                          user.desa!.provinsi ?? ''),
+                    ],
+                  ],
+                );
+              }),
+            ],
+            if (user.role?.toLowerCase() == 'donatur') ...[
+              const SizedBox(height: 24),
+              const Text(
+                'Informasi Donatur',
+                style: TextStyle(
+                  fontSize: 18,
+                  fontWeight: FontWeight.bold,
+                ),
+              ),
+              const SizedBox(height: 16),
+              Obx(() {
+                final roleData = controller.roleData.value;
+                return Column(
+                  crossAxisAlignment: CrossAxisAlignment.start,
+                  children: [
+                    _buildInfoRow(Icons.business, 'Instansi',
+                        roleData?['instansi'] ?? '-'),
+                    const SizedBox(height: 8),
+                    _buildInfoRow(
+                        Icons.work, 'Jabatan', roleData?['jabatan'] ?? '-'),
+                  ],
+                );
+              }),
+            ],
+            if (user.role?.toLowerCase() == 'petugas_desa') ...[
+              const SizedBox(height: 24),
+              const Text(
+                'Informasi Petugas Desa',
+                style: TextStyle(
+                  fontSize: 18,
+                  fontWeight: FontWeight.bold,
+                ),
+              ),
+              const SizedBox(height: 16),
+              Obx(() {
+                final roleData = controller.roleData.value;
+                return Column(
+                  crossAxisAlignment: CrossAxisAlignment.start,
+                  children: [
+                    _buildInfoRow(Icons.badge, 'NIP', roleData?['nip'] ?? '-'),
+                    const SizedBox(height: 8),
+                    _buildInfoRow(
+                        Icons.work, 'Jabatan', roleData?['jabatan'] ?? '-'),
+                    if (user.desa != null) ...[
+                      const SizedBox(height: 8),
+                      _buildInfoRow(
+                          Icons.location_city, 'Desa', user.desa!.nama),
+                      const SizedBox(height: 8),
+                      _buildInfoRow(Icons.location_on, 'Kecamatan',
+                          user.desa!.kecamatan ?? ''),
+                      const SizedBox(height: 8),
+                      _buildInfoRow(Icons.location_on, 'Kabupaten',
+                          user.desa!.kabupaten ?? ''),
+                      const SizedBox(height: 8),
+                      _buildInfoRow(Icons.location_on, 'Provinsi',
+                          user.desa!.provinsi ?? ''),
+                    ],
+                  ],
+                );
+              }),
+            ],
+          ],
         ],
       );
     });
@@ -230,4 +338,23 @@ class ProfileView extends GetView<ProfileController> {
       ),
     );
   }
+
+  Widget _buildInfoRow(IconData icon, String label, String value) {
+    return Row(
+      crossAxisAlignment: CrossAxisAlignment.start,
+      children: [
+        Icon(icon, size: 18, color: Colors.grey[700]),
+        const SizedBox(width: 8),
+        Expanded(
+          child: Text(
+            '$label: $value',
+            style: TextStyle(
+              fontSize: 14,
+              color: Colors.grey[700],
+            ),
+          ),
+        ),
+      ],
+    );
+  }
 }
diff --git a/lib/app/modules/warga/controllers/warga_dashboard_controller.dart b/lib/app/modules/warga/controllers/warga_dashboard_controller.dart
index 91f899f..30cde09 100644
--- a/lib/app/modules/warga/controllers/warga_dashboard_controller.dart
+++ b/lib/app/modules/warga/controllers/warga_dashboard_controller.dart
@@ -11,7 +11,7 @@ class WargaDashboardController extends GetxController {
   final AuthController _authController = Get.find<AuthController>();
   final SupabaseService _supabaseService = SupabaseService.to;
 
-  final Rx<UserModel?> currentUser = Rx<UserModel?>(null);
+  final Rx<BaseUserModel?> currentUser = Rx<BaseUserModel?>(null);
 
   // Indeks tab yang aktif di bottom navigation bar
   final RxInt activeTabIndex = 0.obs;
@@ -41,9 +41,18 @@ class WargaDashboardController extends GetxController {
   final RxInt jumlahNotifikasiBelumDibaca = 0.obs;
 
   // Getter untuk data user
-  UserModel? get user => _authController.user;
+  BaseUserModel? get user => _authController.baseUser;
   String get role => user?.role ?? 'WARGA';
-  String get nama => user?.name ?? 'Warga';
+  String get nama {
+    // Gunakan namaLengkap dari roleData jika tersedia
+    if (_authController.isWarga && _authController.roleData != null) {
+      return _authController.roleData.namaLengkap ??
+          _authController.displayName;
+    }
+    // Gunakan displayName dari AuthController
+    return _authController.displayName;
+  }
+
   String? get desa => user?.desa?.nama;
 
   @override
@@ -54,7 +63,30 @@ class WargaDashboardController extends GetxController {
   }
 
   void loadUserData() {
-    currentUser.value = _authController.user;
+    currentUser.value = _authController.baseUser;
+
+    // Tambahkan log debugging
+    print('DEBUG WARGA: Memuat data user dari AuthController');
+    print('DEBUG WARGA: baseUser: ${_authController.baseUser}');
+    print('DEBUG WARGA: roleData: ${_authController.roleData}');
+    print('DEBUG WARGA: nama yang akan ditampilkan: ${nama}');
+    print(
+        'DEBUG WARGA: displayName dari auth controller: ${_authController.displayName}');
+
+    if (_authController.userData != null) {
+      print(
+          'DEBUG WARGA: userData ada, role: ${_authController.userData!.baseUser.roleName}');
+
+      if (_authController.isWarga) {
+        print('DEBUG WARGA: User adalah warga');
+        var wargaData = _authController.roleData;
+        print('DEBUG WARGA: Data warga: ${wargaData?.namaLengkap}');
+      } else {
+        print('DEBUG WARGA: User bukan warga');
+      }
+    } else {
+      print('DEBUG WARGA: userData null');
+    }
   }
 
   void fetchData() async {
@@ -90,14 +122,8 @@ class WargaDashboardController extends GetxController {
       // Reset data terlebih dahulu untuk memastikan tidak ada data lama yang tersimpan
       penerimaPenyaluran.clear();
 
-      // Pertama, cari warga_id berdasarkan user_id
-      final wargaResponse = await _supabaseService.client
-          .from('warga')
-          .select('id')
-          .eq('user_id', user!.id)
-          .single();
-
-      final wargaId = wargaResponse['id'];
+      // Gunakan langsung ID pengguna sebagai warga_id
+      final wargaId = user!.id;
 
       // Ambil data penerima penyaluran dengan join ke warga, stok bantuan, dan penyaluran bantuan
       final response =
@@ -221,14 +247,8 @@ class WargaDashboardController extends GetxController {
   // Fungsi untuk mengambil data pengajuan kelayakan
   Future<void> fetchPengajuanKelayakan() async {
     try {
-      // Pertama, cari warga_id berdasarkan user_id
-      final wargaResponse = await _supabaseService.client
-          .from('warga')
-          .select('id')
-          .eq('user_id', user!.id)
-          .single();
-
-      final wargaId = wargaResponse['id'];
+      // Gunakan langsung ID pengguna sebagai warga_id
+      final wargaId = user!.id;
 
       final response = await _supabaseService.client
           .from('xx02_pengajuan_kelayakan_bantuan')
@@ -257,19 +277,17 @@ class WargaDashboardController extends GetxController {
       totalPengajuanDitolak.value =
           pengajuan.where((p) => p.status == StatusKelayakan.DITOLAK).length;
     } catch (e) {
-      print('Error fetching pengajuan kelayakan: $e');
+      print('Error fetchPengajuanKelayakan: $e');
     }
   }
 
   // Fungsi untuk mengambil data pengaduan
   Future<void> fetchPengaduan() async {
     try {
-      final wargaData = await _supabaseService.getWargaByUserId();
-      if (wargaData == null) {
-        return;
-      }
+      // Gunakan langsung ID user dari AuthController, bukan getWargaByUserId()
+      String wargaId = user!.id;
+      print('DEBUG WARGA: Mengambil pengaduan untuk warga ID: $wargaId');
 
-      final String wargaId = wargaData['id'];
       final response = await _supabaseService
           .getPengaduanWargaWithPenerimaPenyaluran(wargaId);
 
@@ -287,15 +305,21 @@ class WargaDashboardController extends GetxController {
             .length;
         totalPengaduanSelesai.value =
             pengaduanList.where((p) => p.status == 'SELESAI').length;
+
+        print(
+            'DEBUG WARGA: Berhasil mendapatkan ${pengaduanList.length} pengaduan');
+      } else {
+        print('DEBUG WARGA: Tidak ada pengaduan yang ditemukan');
       }
     } catch (e) {
-      print('Error fetching pengaduan: $e');
+      print('DEBUG WARGA: Error fetching pengaduan: $e');
     }
   }
 
   // Fungsi untuk mengambil data notifikasi
   Future<void> fetchNotifikasi() async {
     try {
+      // Notifikasi masih menggunakan user_id karena tabelnya terpisah
       final response = await _supabaseService.client
           .from('notifikasi')
           .select('*')
@@ -429,13 +453,8 @@ class WargaDashboardController extends GetxController {
     try {
       isLoading.value = true;
 
-      // Cari warga_id berdasarkan user_id
-      final wargaData = await _supabaseService.getWargaByUserId();
-      if (wargaData == null) {
-        throw Exception('Data warga tidak ditemukan');
-      }
-
-      final String wargaId = wargaData['id'];
+      // Gunakan langsung ID pengguna sebagai warga_id
+      final String wargaId = user!.id;
 
       // Upload foto pengaduan jika ada
       List<String> fotoPengaduanUrls = [];
diff --git a/lib/app/services/auth_service.dart b/lib/app/services/auth_service.dart
index 5fe8c92..3d8e220 100644
--- a/lib/app/services/auth_service.dart
+++ b/lib/app/services/auth_service.dart
@@ -7,15 +7,17 @@ class AuthService extends GetxService {
   final Dio _dio = Dio();
   final FlutterSecureStorage _storage = const FlutterSecureStorage();
 
-  final Rx<User?> currentUser = Rx<User?>(null);
+  final Rx<BaseUserModel?> currentUser = Rx<BaseUserModel?>(null);
+  String? _token;
 
   // Mendapatkan data user saat ini
-  Future<User?> getCurrentUser() async {
+  Future<BaseUserModel?> getCurrentUser() async {
     try {
       // Implementasi untuk mendapatkan data user dari API atau local storage
       // Contoh implementasi sederhana:
       final token = await _storage.read(key: 'token');
       if (token == null) return null;
+      _token = token;
 
       final response = await _dio.get(
         '/api/user/profile',
@@ -27,7 +29,7 @@ class AuthService extends GetxService {
       );
 
       if (response.statusCode == 200) {
-        final user = User.fromJson(response.data['data']);
+        final user = BaseUserModel.fromJson(response.data['data']);
         currentUser.value = user;
         return user;
       }
@@ -40,7 +42,7 @@ class AuthService extends GetxService {
   }
 
   // Update profil user
-  Future<bool> updateProfile(User user) async {
+  Future<bool> updateProfile(BaseUserModel user) async {
     try {
       final token = await _storage.read(key: 'token');
       if (token == null) return false;
@@ -50,7 +52,7 @@ class AuthService extends GetxService {
         data: {
           'name': user.name,
           'email': user.email,
-          'phone': user.phone,
+          // 'phone' tidak tersedia di BaseUserModel, jadi kita hilangkan atau gunakan parameter lain
         },
         options: Options(
           headers: {
@@ -100,7 +102,7 @@ class AuthService extends GetxService {
   }
 
   // Login
-  Future<User?> login(String email, String password) async {
+  Future<BaseUserModel?> login(String email, String password) async {
     try {
       final response = await _dio.post(
         '/api/auth/login',
@@ -111,11 +113,13 @@ class AuthService extends GetxService {
       );
 
       if (response.statusCode == 200) {
-        final user = User.fromJson(response.data['data']);
+        final user = BaseUserModel.fromJson(response.data['data']);
 
-        // Simpan token
-        if (user.token != null) {
-          await _storage.write(key: 'token', value: user.token);
+        // Simpan token yang datang dari respons
+        if (response.data['token'] != null) {
+          final token = response.data['token'].toString();
+          await _storage.write(key: 'token', value: token);
+          _token = token;
         }
 
         currentUser.value = user;
@@ -148,6 +152,7 @@ class AuthService extends GetxService {
     } finally {
       // Hapus token dan user data
       await _storage.delete(key: 'token');
+      _token = null;
       currentUser.value = null;
 
       // Navigasi ke halaman login
@@ -155,6 +160,12 @@ class AuthService extends GetxService {
     }
   }
 
+  // Mendapatkan token autentikasi
+  Future<String?> getToken() async {
+    if (_token != null) return _token;
+    return await _storage.read(key: 'token');
+  }
+
   // Inisialisasi service
   Future<AuthService> init() async {
     // Coba mendapatkan user saat ini
